// Ex4.7.3 (c) 2007 Kawanishi, Hiroyuki
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Media.Animation;
using System.Windows.Media.Media3D;
using System.Windows.Shapes;


namespace Ex4_7_3
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>

    public partial class Window1 : System.Windows.Window
    {
        private MediaPlayer mp1;
        private MediaPlayer mp2;
        Storyboard myPanelStoryboardForward;
        Storyboard myPanelStoryboardBackward;

        public Window1()
        {
            InitializeComponent();

            // fBAv[
            
            mp1 = new MediaPlayer();
            mp1.Open(new Uri(@"Media\video1.wmv", UriKind.Relative));
            mp1.MediaEnded += new System.EventHandler(this.MediaEnded);
            myVideoDrawingF1.Player = myVideoDrawingB1.Player = mp1;
            mp1.Play();

            mp2 = new MediaPlayer();
            mp2.Open(new Uri(@"Media\video2.wmv", UriKind.Relative));
            mp2.MediaEnded += new System.EventHandler(this.MediaEnded);
            myVideoDrawingF2.Player = myVideoDrawingB2.Player = mp2;
            mp2.Play();
            mp2.MediaOpened += new EventHandler(MediaOpened);

            // plXg[[{[h\[X擾
            myPanelStoryboardForward = (Storyboard)this.Resources["myPanelStoryboardForwardResource"];
            myPanelStoryboardBackward = (Storyboard)this.Resources["myPanelStoryboardBackwardResource"];
            myPanelStoryboardBackward.Completed += new System.EventHandler(this.ScaleAnimationCompleted);

        }
        // fBÃI[v҂R[obN
        void MediaOpened(object sender, EventArgs e)
        {
            myViewport3D.Visibility = Visibility.Visible;
        }
        //fBAĐIɌJԂsR[obN
        void MediaEnded(object sender, EventArgs e)
        {
            MediaPlayer mp = sender as MediaPlayer;
            mp.Stop();
            mp.Play();
        }
        // plAj[VIɃfBAR[obN
        void ScaleAnimationCompleted(object sender, EventArgs e)
        {
            MyVideoDrawingF3.Player = MyVideoDrawingB3.Player = null;
            mp1.Volume = 1.0; mp2.Volume = 0.0; 
        }
        // Viewport3DNbÑqbgeXg
        public void OnClick(object sender, System.Windows.Input.MouseButtonEventArgs args)
        {
            Point mouseposition = args.GetPosition(myViewport3D);
            Point3D testpoint3D = new Point3D(mouseposition.X, mouseposition.Y, 0);
            Vector3D testdirection = new Vector3D(mouseposition.X, mouseposition.Y, 10);
            PointHitTestParameters pointparams = new PointHitTestParameters(mouseposition);
            VisualTreeHelper.HitTest(myViewport3D, null, HTResult, pointparams);
        }

        // qbgeXgʂɂplAj[V̊Jn
        public HitTestResultBehavior HTResult(System.Windows.Media.HitTestResult rawresult)
        {
            if (rawresult != null)
            {
                RayMeshGeometry3DHitTestResult rayMeshResult = rawresult as RayMeshGeometry3DHitTestResult;

                if (rayMeshResult != null)
                {
                    Visual3D v3d = rayMeshResult.VisualHit as Visual3D;

                    if (v3d.Equals(myModel1))
                    {
                        MyVideoDrawingF3.Player = MyVideoDrawingB3.Player = mp1;
                        mp1.Volume = 1.0; mp2.Volume = 0.0;
                        myPanelStoryboardForward.Begin(myViewport3D);
                    }
                    else if (v3d.Equals(myModel2))
                    {
                        MyVideoDrawingF3.Player = MyVideoDrawingB3.Player = mp2;
                        mp1.Volume = 0.0; mp2.Volume = 1.0;
                        myPanelStoryboardForward.Begin(myViewport3D);
                    }
                    else if (v3d.Equals(myPlaneScreen))
                    {
                        myPanelStoryboardBackward.Begin(myViewport3D);
                    }
                    else
                    {
                        MyVideoDrawingF3.Player = MyVideoDrawingB3.Player = null;
                    }
                }
            }
            return HitTestResultBehavior.Stop;
        }
    }
}