// Ex5.4.4 (c) 2007 Kawanishi, Hiroyuki 
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Media.Animation;
using System.Windows.Shapes;


namespace Ex5_4_4
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>

    public partial class Window1 : System.Windows.Window
    {
        private MediaClock myMediaClock;

        public Window1()
        {
            InitializeComponent();

            MediaTimeline myMediaTimeline = new MediaTimeline(new Uri("Media\\Video1.wmv", UriKind.Relative));
            myMediaTimeline.CurrentTimeInvalidated += new EventHandler(MediaTimeChanged);
            myMediaClock = myMediaTimeline.CreateClock();
            myMediaClock.Controller.Stop();
            myMediaElement.Clock = myMediaClock;
        }

        private void PlayClicked(object sender, RoutedEventArgs e)
        {
            myMediaClock.Controller.Begin();
        }
        private void PauseClicked(object sender, RoutedEventArgs e)
        {
            myMediaClock.Controller.Pause();
        }
        private void StopClicked(object sender, RoutedEventArgs e)
        {
            myMediaClock.Controller.Stop();
            myCurrentPosition.Value = 0.0; 
        }
        private void ResumeClicked(object sender, RoutedEventArgs e)
        {
            myMediaClock.Controller.Resume();
        }
        private void MediaOpened(object sender, EventArgs e)
        {
            myCurrentPosition.Maximum = myMediaClock.NaturalDuration.TimeSpan.TotalMilliseconds;
            mySeekSlider.Maximum = myMediaClock.NaturalDuration.TimeSpan.TotalMilliseconds;
        }

        private void MediaTimeChanged(object sender, EventArgs e)
        {
            if (myMediaClock.CurrentTime != null)
               myCurrentPosition.Value = myMediaClock.CurrentTime.Value.TotalMilliseconds;
        }

       private void OnSeekSlider(object sender, EventArgs e)
        {
            Slider mySlider = sender as Slider;
            myMediaClock.Controller.Seek(
               new TimeSpan((long)Math.Floor(mySeekSlider.Value * TimeSpan.TicksPerMillisecond)),
               TimeSeekOrigin.BeginTime);
       }
    }
}