using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Media;
using System.Windows.Shapes;
using System.ComponentModel;

namespace DataBindingLab
{
    public partial class MainWindow : Window
    {
        CollectionViewSource listingDataView;

        public MainWindow()
        {
            InitializeComponent();
            listingDataView = (CollectionViewSource)(this.Resources["listingDataView"]);
        }
        

        private void ShowOnlyBargainsFilter(object sender, FilterEventArgs e)
        {
            Person people = e.Item as Person ;
            if (people != null)
            {
                // Filter out products with price 25 or above
                if (people.HomeTown == "")
                {
                    e.Accepted = true;
                }
                else
                {
                    e.Accepted = false;
                }
            }
        }

        private void AddFiltering(object sender, RoutedEventArgs args)
        {
            listingDataView.Filter += new FilterEventHandler(ShowOnlyBargainsFilter);
        }


        private void RemoveFiltering(object sender, RoutedEventArgs args)
        {
            listingDataView.Filter -= new FilterEventHandler(ShowOnlyBargainsFilter);
        }
    }
}